<?php
/**
 * This file is part of Theme for 
 * pragmaMx - Web Content Management System.
 *
 * $template : alaSimpleBT $
 * $Revision: 1.0 $
 * 
 * Theme for pragmaMx Content Management System Platform<br>- HTML5 ready <br>
 * 
 * $Version: 1.0 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/06/16  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );

include_once (dirname ( dirname ( __FILE__ ) ) . "/includes/class.theme_functions.php");
include_once (dirname ( dirname ( __FILE__ ) ) . DS . "setup.pmx.php");
/**
 * theme_admin
 *
 * @package
 *
 * @author aLaNiSo
 * @copyright Copyright (c) 2014
 * @access public
 */
class theme_admin {
  private $errors = array ();
  private $form = null;
  private $homepage = '';
  private static $__set = array (); // Konfiguration
  private $kf = null;
  private static $_config = null;
  public $themename = '';

  /**
   * class::__construct()
   *
   * @param string $parameter          
   */
  function __construct($parameter = "") {

    global $prefix;
    
    mxGetLangfile ( __DIR__ );
    
    $this->themename = basename ( dirname ( __DIR__ ) );
    
    $this->kf = new theme_functions ( $this->themename );
    $this->op = $parameter;
    self::$_config = $this->config_load ();
    $this->main ( $this->op );
  }

  /**
   * class::__get()
   *
   * @param mixed $value_name          
   * @return
   *
   */
  public function __get($value_name) {

    if (isset ( self::$__set [$value_name] )) {
      return self::$__set [$value_name];
    }
    return false;
  }

  /**
   * class::__set()
   *
   * @param mixed $name          
   * @param mixed $val          
   * @return
   *
   */
  public function __set($name, $val) {

    self::$__set [$name] = $val;
  }

  /**
   * class::main()
   *
   * @param string $action          
   * @return
   *
   */
  function main($op) {

    global $credits;
    $info2 = $this->themename;
    $tb = load_class ( 'AdminForm', "adminFormMain" );
    $redirect = false;
    
    /* definitionen voreinstellungen */
    
    switch (pmxAdminForm::CheckButton ()) {
      case "save" :
        $redirect = true;
      case "accept" :
        $temp = $_POST ['config'];
        $config = $this->config_load ();
        
        switch (true) {
          case (trim ( $temp ['sitename'] == "" )) :
            $temp ['sitename'] = $GLOBALS ['sitename'];
          case (trim ( $temp ['slogan'] == "" )) :
            $temp ['slogan'] = $GLOBALS ['slogan'];
        }
        $temp = array_merge ( $config, $temp );
        $this->config_save ( $temp );
        if ($redirect)
          mxRedirect ( "admin.php?op=themes", _CHANGESAREOK, 1 );
        break;
    }
    
    $config = $this->config_load ();
    
    echo "<h3>".$info2."</h3>";
    $themeimg="themes/".$this->themename."/theme_thumbnail.png";
    $themeimage= (file_exists($themeimg))?"<img src=\"".$themeimg."\" style=\"width:100px;float:left;\" />":"no preview";
    
    $tb = load_class ( 'AdminForm', "adminFormMain" );
    $tb->tb_text = $themeimage;
    $tb->tb_direction = 'right';
    $tb->infobutton = true;
    $tb->tb_pic_heigth = 22;
    $tb->cssclass = "toolbar1";
    $tb->homelink = false;
    
    $tb->addToolbar ( "save" );
    $tb->addToolbar ( "accept" );
    
    $tb->addToolbarLink ( "cpanel", "admin.php?op=themes" );
    
    $navbarposition = array (
    		"navbar-fixed-top" => "navbar-fixed-top",
    		"navbar-fixed-bottom" => "navbar-fixed-bottom",
    		"navbar-static-top" => "navbar-static-top",
    );
    
    
    /* Form elements */
    $tb->addFieldSet ( "head", _SETTINGS, "", false );
    $tb->add ( "head", "input", "config[sitename]", $config ['sitename'], _THEME_TITLE, "", 50, 50 );
    $tb->add ( "head", "filebrowse", "config[logo]", $config ['logo'], _THEME_LOGO, _THEME_LOGO_INFO, 40, array (
            'type' => 'images',
            'showimage' => true 
        ) );
    
    $tb->add ( "head", "editor", "config[jumbotron]", $config ['jumbotron'], _THEME_JUMBOTRON, _THEME_JUMBOTRON_INFO, 40, array (
    		'height' => 100
    ) );
    $tb->add ( "head", "input", "config[head_css_menu]", $config ['head_css_menu'], _THEME_MENU, "", 50, 50 );
    $tb->add ( "head", "select", "config[navbarposition]", $config ['navbarposition'], _THEME_NAVBARPOSITION, _THEME_NAVBARPOSITION_INFO, 1, $navbarposition );
    
    $tb->addFieldSet("social", _THEME_SOCIAL_SETTINGS, "", true);
    $tb->add("social", "input", "config[facebooklink]", $config['facebooklink'], _THEME_FACEBOOKLINK, _THEME_FACEBOOKLINK_INFO, 50, 50);
    $tb->add("social", "input", "config[twitterlink]", $config['twitterlink'], _THEME_TWITTERLINK, _THEME_TWITTERLINK_INFO, 50, 50);
    $tb->add("social", "input", "config[rsslink]", $config['rsslink'], _THEME_RSSLINK, _THEME_RSSLINK_INFO, 50, 50);
    
    $tb->add ( "head", "hidden", "ok", "1" );
    
    $out = $tb->Show ();
    $out .= "<hr><p class=\"align-center\" >$credits</p>";
    $out .= $this->alaniso_vcheck ();
    
    echo $out;
  }

  /**
   * class::config_save()
   * Konfiguration auslesen .
   *
   *
   * ...
   *
   * @param array $temp          
   * @return
   *
   */
  function config_save($temp = array()) {

    $this->kf->config_save ( $temp );
  }

  /**
   * class::config_load()
   *
   * @return
   *
   */
  function config_load() {

    $temp = $this->kf->config_load ();
    
    return $temp;
  }
  
  private function alaniso_vcheck() {
  
  	global $currentlang, $theme_version, $credits;
    $check = '';
  	// Versionscheck nur 1x pro Sessionlifetime
  	$past = time () - MX_SESSION_LIFETIME;
  	$lasttime = mxSessionGetVar ( $this->themename . 'vcheck' );
  	if ((mxSessionGetVar ( $this->themename . 'vcheck' ) + MX_SESSION_LIFETIME) > time ()) {
  		return $check;
  	}
  	mxSessionSetVar ( $this->themename . 'vcheck', time () );
  
  	$module = 'theme_' . $this->themename;
  	// Zuerst von der Versionsverwaltung die URL zum Modul-Check holen:
  	$updateurl = $this->alaniso_vcheck_connect ( "http://www.vcheck.alaniso.de/index.php" );
  	if ($updateurl == false)
  		return $check;
  	// return 'Versions-Check: nicht moeglich!';
  
  	// Versionscheck durchfuehren:
  	$update1 = $this->alaniso_vcheck_connect ( "http://" . $updateurl . "&module=" . $module . "&version=" . $theme_version . "&lang=" . $currentlang . "&site=" . strip_tags ( PMX_HOME_URL ) );
  	if ($update1 == false)
  		return $check;
  	// return 'Versions-Check: Kein Ergebnis fuer Modul: ' . "http://" . $updateurl . '<br>' . $update1;
  
  	$update = @unserialize ( json_decode ( trim ( $update1 ), TRUE ) );
  
  	if (! is_array ( $update ))
  		return $check;
  	// return 'Versions-Check: Ergebnis ist kein Array!' . "http://" . $updateurl . '<br>' . $update1;
  
  	if ($update ['check']) { // ok
  		$check .= "<div class=\"note\">";
  		$check .= "<h4>" . $update ['title'] . "</h4>";
  		$check .= $update ['text'] . ":" . $update ['version'] . "<br />";
  		$check .= "<br />";
  	} else { // new version
  		$check .= "<div class=\"warning\">";
  		$check .= "<h4>" . $update ['title'] . "</h4>";
  		$check .= $update ['text'] . " [ " . $update ['version'] . " ]<br />";
  		$check .= "<a href=\"" . $update ['updateurl'] . "\" target=\"_blank\" >" . $update ['updateurl'] . "</a><br />";
  	}
  	$check .= "<hr /><div class=\"tiny\">" . $update ['info'] . "&nbsp;:&nbsp;";
  	$check .= "<a href=\"" . $update ['url'] . "\" target=\"_blank\" >" . $update ['url'] . "</a></div>";
  	$check .= "</div>";
  
  	return $check;
  }
  
  private function alaniso_vcheck_connect($url = "") {
  
  	if ($url == "")
  		return;
  	$useragent = $_SERVER ['HTTP_USER_AGENT'];
  	$result = false;
  	$msg = '';
  	if (function_exists ( "curl_init" )) {
  		/**
  		 * cURL-Session initialisieren
  		 */
  		$ch = curl_init ( $url );
  		/**
  		 * Weiter Parameter der cURL-Session übergeben
  		*/
  		curl_setopt ( $ch, CURLOPT_URL, $url );
  		curl_setopt ( $ch, CURLOPT_HEADER, 0 );
  		// Post-Daten
  		curl_setopt ( $ch, CURLOPT_POST, TRUE );
  		curl_setopt ( $ch, CURLOPT_POSTFIELDS, $msg );
  
  		/**
  		 * cURL Anweisen, das die Übergabe
  		 * zurückgegeben werden soll
  		*/
  		curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, TRUE );
  		curl_setopt ( $ch, CURLOPT_FOLLOWLOCATION, 1 );
  
  		/**
  		 * cURL mitteilen, welcher Useragent übergeben
  		 * werden soll.
  		*/
  		curl_setopt ( $ch, CURLOPT_USERAGENT, $useragent );
  		/**
  		 * cURL Rückgabe in $result speichern
  		*/
  		$result = @curl_exec ( $ch );
  		curl_close ( $ch );
  	} else {
  		// echo "Function: curl_init nicht vorhanden!";
  	}
  	if (trim ( $result ) == "FORBIDDEN")
  		return false;
  
  	return $result;
  }
  
}

if (! isset ( $op ))
  $op = "";
$tmp = new theme_admin ( $op );
$tmp = null;

?>