<?php
/**
 * This file is part of Theme for 
 * pragmaMx - Web Content Management System.
 *
 * $template : alaSimpleBT $
 * $Revision: 1.0 $
 * 
 * Theme for pragmaMx Content Management System Platform<br>- HTML5 ready <br>
 * 
 * $Version: 1.0 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/06/16  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );


/**
 * Definition der jeweiligen Platzhalter und deren Ersetzungen
 */
function theme_define_placeholders() {
	global $themesetting;
	$part [] = array (
			"{PAGE_SITENAME}",
			$themesetting ['sitename'] 
	);
	$part [] = array (
			"{PAGE_SLOGAN}",
			$themesetting ['slogan'] 
	);
	
	$part[] = array("{LINK_RSSFEED}", theme_get_tag_rss());
	$part[] = array("{LINK_FACEBOOK}", theme_get_tag_facebook());
	$part[] = array("{LINK_TWITTER}", theme_get_tag_twitter());
	
	
	$part [] = array (
			"{FOOTMESSAGE1}",
			theme_get_footmsg ( 1 ) 
	);
	$part [] = array (
			"{FOOTMESSAGE2}",
			theme_get_footmsg ( 2 ) 
	);
	$part [] = array (
			"{FOOTMESSAGE3}",
			theme_get_footmsg ( 3 ) 
	);
	$part [] = array (
			"{FOOTMESSAGE4}",
			theme_get_footmsg ( 4 ) 
	);
	$part [] = array (
			"{DEBUGSERVICE}",
			theme_get_servicetext ( 'debugservice' ) 
	);
	$part [] = array (
			"{SITESERVICE}",
			theme_get_servicetext ( 'siteservice' ) 
	);
	$part [] = array (
			"{NAVBAR}",
			theme_get_navbars ( 1 ) 
	);
	$part [] = array (
			"{NAVBARPOSITION}",
			$themesetting['navbarposition'] 
	);
	$part [] = array (
			"{CURRENTYEAR}",
			date ( 'Y' ) 
	);
	$part [] = array (
			"{LOGINFORM}",
			theme_loginform () 
	);
	$part [] = array (
			"{SEARCHFORM}",
			theme_searchform () 
	);
	$part [] = array (
			"{FOOTERNAV}",
			theme_footernav () 
	);
	// Banner anzeigen
	$part [] = array (
			"{BANNER1}",
			theme_show_banner ( 1 ) 
	); // HeaderBanner
	$part [] = array (
			"{BANNER2}",
			theme_show_banner ( 2 ) 
	); // FooterBanner
	$part [] = array (
			"{BANNER7}",
			theme_show_banner ( 7 ) 
	); // Skyscraper
	$part [] = array (
			"{BANNER6}",
			theme_show_banner ( 6 ) 
	); // rechter Banner
	   // Jumbotron
	$part [] = array ("{JUMBOTRON}", theme_get_jumbotron ());
	// Logo
	$part [] = array ("{LOGO}",	$themesetting['logo']);
	
	$doctype_arr = mxDoctypeArray ( $GLOBALS ['DOCTYPE'] );
	list ( $type, $number ) = explode ( ' ', $doctype_arr ['name'] );
	if (is_numeric ( $number )) {
		$type .= '&nbsp;' . $number;
	}
	
// 	$part [] = array (
// 			"{THEMENAME}",
// 			basename ( __DIR__  ) 
// 	);
	$part [] = array ("{THEMENAME}", basename(MX_THEME_DIR));
	$part [] = array (
			"{HTML}",
			$type 
	);
	
	return $part;
}

/**
 * Definition der einzelnen Blockbereiche
 */
function theme_define_blocks() {
	global $themesetting;
	
	static $var;
	if (isset ( $var ))
		return $var;
		// linke Bloecke
	$name = 'block_left';
	$var [$name] ['container'] = 'blocks_left_loop';
	$var [$name] ['function'] = 'themesidebox';
	$var [$name] ['position'] = 'l';
	// obere Center-Bloecke
	$name = 'block_center_top';
	$var [$name] ['container'] = 'blocks_center_top_loop';
	$var [$name] ['function'] = 'thememiddlebox';
	$var [$name] ['position'] = 'c';
	// untere Center-Bloecke
	$name = 'block_center_down';
	$var [$name] ['container'] = 'blocks_center_down_loop';
	$var [$name] ['function'] = 'thememiddlebox';
	$var [$name] ['position'] = 'd';
	// rechte Bloecke
	$name = 'block_right';
	$var [$name] ['container'] = 'blocks_right_loop';
	$var [$name] ['function'] = 'themesidebox';
	$var [$name] ['position'] = 'r';
	return $var;
}

/**
 * Definition des Contentbereiches inkl.
 * der open/close-Table Funktionen
 */
function theme_define_content() {
	static $var;
	if (isset ( $var ))
		return $var;
		// die Funktion OpenTable()
	$var ['opentabs'] ['OpenTable'] ['templatevar'] = 'opentable';
	$var ['opentabs'] ['OpenTable'] ['innerreplace'] = '{OPENCLOSE_TABLE}'; // hier kann irgendwas stehen, es muss aber mit dem entsprechenden Text innerhalb der template-Datei uebereinstimmen...
	                                                                        // die Funktion OpenTable2()
	$var ['opentabs'] ['OpenTable2'] ['templatevar'] = 'opentable2';
	$var ['opentabs'] ['OpenTable2'] ['innerreplace'] = '{OPENCLOSE_TABLE_2}';
	// die Funktion OpenTableAl()
	$var ['opentabs'] ['OpenTableAl'] ['templatevar'] = 'opentableal';
	$var ['opentabs'] ['OpenTableAl'] ['innerreplace'] = '{OPENCLOSE_TABLE_AL}';
	// die Funktion themeindex() / News Modul
	$var ['themeindex'] = 'themeindex';
	// die Funktion themearticle() / News Modul
	$var ['themearticle'] = 'themearticle';
	// der Name (output_container) darf nicht veraendert werden !!
	$var ['output_container'] = 'script_output';
	// der Name (index_on_container) darf nicht veraendert werden !!
	$var ['index_on_container'] = 'blocks_right_container';
	$var ['index_on_block_container'] = 'blocks_right_loop';
	// der Name (more_header) darf nicht veraendert werden !!
	$var ['add_header'] = 'more_header';
	
	return $var;
}

/**
 * Ermittlung des JumboTron - Grossbildleinwand
 *
 * @return string
 */
function theme_get_jumbotron() {
	global $themesetting;
	
	// Only, whether no module is active...
	if (! isset ( $_GET ['name'] )) {
		$out = '<div class="jumbotron">';
		$out .= $themesetting ['jumbotron'];
		$out .= '<a href="modules.php?name=Search" class="btn btn-info btn-lg"><span class="glyphicon glyphicon-search"></span> Search</a>';
		$out .= '</div>';
	} else {
		$out = '';
	}
	
	return $out;
}

/**
 * Die verschiedenen Layout-Spalten definieren
 * das Ganze wird in Funktion theme_header() angewendet
 */
function theme_get_layout_class() {
	global $themesetting;
	
	$class = '';
	
	switch ($themesetting ['layouttype']) {
		case 'fluid' :
			$class .= ' fluid';
			break;
		case 'fixed' :
		default :
			$class .= ' fixed';
	}
	
	switch (true) {
		case theme_hidesideblocks () :
		case theme_hiderightblocks () && theme_hideleftblocks () :
			// einspaltiges Layout
			$class .= ' col-1';
			break;
		
		case theme_hiderightblocks () :
		case isset ( $_GET ['about'] ) && $_GET ['about'] === basename ( _THISTHEME_ ) :
			// zweispaltiges Layout
			$class .= ' col-2-left';
			switch ($themesetting ['layoutcols']) {
				case 'right' :
					$class .= ' col-to-right';
					break;
				default :
			}
			break;
		
		case theme_hideleftblocks () :
			// zweispaltiges Layout, rechts ist aber links!!
			$class .= ' col-2-right';
			switch ($themesetting ['layoutcols']) {
				case 'left' :
					$class .= ' col-to-left';
					break;
				default :
			}
			break;
		
		default :
			// dreispaltiges Layout > Standard
			switch ($themesetting ['layoutcols']) {
				case 'left' :
					$class .= ' col-3-left';
					break;
				case 'right' :
					$class .= ' col-3-right';
					break;
				default :
					$class .= ' col-3';
			}
			break;
	}
	$class .= ' bodymain';
	
	return trim ( $class );
}

/**
 * ersetzen von eigenen Theme-Elementen, kann veraendert und ergaenzt werden
 * diese Teile werden gleich zu Beginn des scriptes, beim einlesen des templates, ersetzt
 * Vorsicht, wenn das Theme gecached werden soll!!!
 * Dann duerfen hier keine dynamischen Elemente eingesetzt werden.
 */
function theme_replace_start($template) {
	global $themesetting;
	/**
	 * bestimmte Texte, vor allem Image-Pfade, die ersetzt werden sollen, definieren (suche/ersetze)
	 */
	$part [] = array ('"style/', '"' . MX_THEME_DIR . '/style/'	); // die Stylesheets
	$part [] = array ('"js/', '"' . MX_THEME_DIR . '/js/' ); // die Javascripte
	$part [] = array ('"images/', '"' . MX_THEME_DIR . '/images/'); // normale images im theme
	$part [] = array ('url(images/', 'url(' . MX_THEME_DIR . '/images/'); // Hintergrundbilder im theme
	   
	// Suchformular entfernen, wenn Suche abgeschaltet ist
	if (! mxModuleAllowed ( 'Search' )) {
		theme_extract_optional_part ( $template, 'searchform', '' );
	}
	// Siteservicebereich entfernen, wenn Siteservice abgeschaltet oder leer ist
	if (! theme_get_servicetext ( 'siteservice' )) {
		theme_extract_optional_part ( $template, 'siteservice', '' );
	}
	// Debugbereich entfernen, wenn Debugmodus abgeschaltet oder leer ist
	if (! theme_get_servicetext ( 'debugservice' )) {
		theme_extract_optional_part ( $template, 'debugservice', '' );
	}
	// das Kopfmenue durch die tatsaechlichen Daten ersetzen
	theme_extract_optional_part ( $template, 'headmenue', '{NAVBAR}' );
	$part [] = array (
			'{CLASS}',
			theme_get_layout_class () 
	);
	
	return theme_replace_parts ( $template, $part );
}

/**
 * ersetzen von eigenen Theme-Elementen, kann veraendert und ergaenzt werden
 * diese Teile werden vor der Ausgabe des headers im Headbereich ersetzt
 */
function theme_replace_header($newheader) {
	
	/* bei Bedarf den XHTML-Dokumenttyp ueberpruefen und Fehlermeldung ausgeben */
	if (MX_IS_ADMIN && ! theme_check_xhtmldoctype ()) {
		$newheader .= '<div class="warning"><h2 class="align-center">' . _FALSEDOCTYPE . '</h2></div>';
	}
	
	return $newheader;
}

/**
 * ersetzen in jedem einzelnen Block
 */
function theme_replace_blocks($template, $block) {
	/* Teil fuer alle Bloecke */
	if (empty ( $block ['title'] ) || $block ['title'] == 'NOTITLE') {
		$part [] = array (
				'__BLOCK_ID__',
				'__BLOCK_ID__ block-hide-caption' 
		);
		$part [] = array (
				'<h2></h2>',
				'' 
		);
		$part [] = array (
				'<div class="nav-header block-title"></div>',
				'' 
		);
	}
	$part [] = array (
			'__BLOCK_ID__',
			'block-' . $block ['position'] . '-' . $block ['order'] . '-bid-' . $block ['bid'] . '' 
	);
	
	return theme_replace_parts ( $template, $part );
}

/**
 * ersetzen von eigenen Theme-Elementen, kann veraendert und ergaenzt werden
 * diese Teile werden am Ende des scriptes, in der Funktion themefooter() ersetzt
 */
function theme_replace_end($template) {
	global $themesetting;
	
	/* die linken Bloecke bei bestimmten Seiten entfernen */
	if (theme_hideleftblocks ()) {
		theme_extract_part ( $template, 'blocks_left_container' );
	}
	
	// einige pmx Class-Attribute auf bootstrap umschiften:
	$part [] = array (
			'class="xxxbutton',
			'class="btn btn-primary' 
	); // Standard-Schaltflächen
	$part [] = array (
			'class="success',
			'class="success alert alert-success' 
	); // Hintergrund-Farbklassen
	$part [] = array (
			'class="important',
			'class="important alert alert-primary' 
	); // Hintergrund-Farbklassen
	$part [] = array (
			'class="note',
			'class="note alert alert-note' 
	); // Hintergrund-Farbklassen
	$part [] = array (
			'class="info',
			'class="info alert alert-info' 
	); // Hintergrund-Farbklassen
	$part [] = array (
			'class="warning',
			'class="warning alert alert-warning' 
	); // Hintergrund-Farbklassen
	$part [] = array (
			'class="error',
			'class="error alert alert-error' 
	); // Hintergrund-Farbklassen
	$part [] = array (
			'class="highlight',
			'class="note highlight' 
	); // Hintergrund-Farbklassen
	return theme_replace_parts ( $template, $part );
	
	return $template;
}

/**
 * pruefen ob linke Bloecke ausgeblendet werden sollen
 */
function theme_hideleftblocks() {
	global $themesetting;
	
	switch (true) {
		case (isset ( $themesetting ['hide-left'] ) && in_array ( 1, $themesetting ['hide-left'] )) :
		case theme_hidesideblocks () :
			return true;
	}
	
	$blocks = mxGetAllBlocks ( 'l' );
	if (! $blocks) {
		// f�r n�chsten Aufruf vereinfachen
		$themesetting ['hide-left'] [] = 1;
		return true;
	}
	return false;
}

/**
 * pruefen ob linke Bloecke ausgeblendet werden sollen
 */
function theme_hiderightblocks() {
	global $themesetting;
	
	switch (true) {
		case empty ( $GLOBALS ['index'] ) :
		case theme_hidesideblocks () :
			return true;
	}
	
	$blocks = mxGetAllBlocks ( 'r' );
	if (! $blocks) {
		// für nächsten Aufruf vereinfachen
		$GLOBALS ['index'] = false;
		return true;
	}
	return false;
}

/**
 * pruefen ob linke Bloecke ausgeblendet werden sollen
 */
function theme_hidesideblocks() {
	global $themesetting;
	return (isset ( $themesetting ['hide-both'] ) && in_array ( 1, $themesetting ['hide-both'] ));
}


/**
 * die Navigationsbuttons im header...
 */
function theme_get_navbars($number) {
	global $themesetting;
	
	/* Menümanager verwenden? */
	if ($themesetting ['head_css_menu']) {
		return theme_get_mxmenu ();
	}
	
	/* ansonsten eben das Array... */
	static $out;
	if (isset ( $out [$number] )) {
		return $out [$number];
	}
	$data = theme_head_data ();
	$count = count ( $data [$number] ) - 1;
	foreach ( $data [$number] as $key => $menue ) {
		switch (true) {
			case ($menue ['current'] && ($key == 0)):
                /* aktuelle Seite und erster Tab */
                $class = ' class="active"';
				break;
			case ($key == 0):
                /* irgendeine Seite und erster Tab */
                $class = ' class="home"';
				break;
			case ($menue ['current']):
                /* aktuelle Seite und irgendein Tab */
                $class = ' class="current"';
				break;
			default:
                /* irgendeine Seite und irgendein Tab */
                $class = '';
		}
		$slogan = (empty ( $menue ['slogan'] )) ? '' : ' title="' . $menue ['slogan'] . '"';
		$navbar [] = '<li><a' . $class . ' href="' . $menue ['link'] . '">' . $menue ['caption'] . '</a></li>';
	}
	$out [$number] = '<ul>' . implode ( "\n", $navbar ) . '</ul>';
	return $out [$number];
}

/**
 * Auslesen der Menüpunkte, wenn Headmenü nicht aus dem Menümanager kommt
 */
function theme_head_data() {
	global $themesetting;
	static $out;
	
	if (isset ( $out )) {
		return $out;
	}
	$out ['current'] = array ();
	foreach ( $themesetting ['headnav'] as $key => $values ) {
		$values ['current'] = false;
		if (in_array ( 1, $values ['case'] )) {
			$out ['current'] = $values;
			$values ['current'] = true;
		}
		if ($values ['menu']) {
			$values ['index'] = $key;
			$out [$values ['menu']] [] = $values;
		}
	}
	return $out;
}

/**
 * in $newheader ist der gesamte angepasste header enthalten
 */
function theme_header($newheader, &$siteservice, &$debugservice) {
	global $theme_template, $themesetting;
	
	/* das Theme verwendet eigene Servicebereiche, deswegen hier die beiden Variablen killen */
	$siteservice = null;
	$debugservice = null;
	
	/* Layout im body-Tag definieren */
	$class = theme_get_layout_class ();
	$theme_template ['body_tag'] = preg_replace ( '#(class\s*=\s*["\'])(.*)(["\'])#', '$1' . trim ( $class ) . '$3', $theme_template ['body_tag'] );
	
	/* den body-Tag hinter head-Ende setzen >> nicht veraendern !! */
	$newheader .= "\n</head>\n\n" . $theme_template ['body_tag'] . "\n\n";
	// ersetzen von eigenen Theme-Elementen, kann veraendert und ergaenzt werden
	// diese Teile werden vor der Ausgabe des headers im Headbereich ersetzt
	$newheader = theme_replace_header ( $newheader );
	
// 	/* Layout-Typ: fluid oder fixed */
// 	switch ($themesetting ['layouttype']) {
// 		case 'fluid' :
// 			pmxHeader::add_style ( MX_THEME_DIR . '/style/layout.fluid.css.php' );
// 			break;
// 		case 'fixed' :
// 		default :
// 			pmxHeader::add_style ( MX_THEME_DIR . '/style/layout.fixed.css.php' );
// 	}
	
	// Alle Scripte und Styles includieren:
	include (MX_THEME_DIR . '/includes/jquerysripts.php');
	
	return $newheader;
}

/**
 * Beschreibung
 */
function theme_loginform() {
	global $prefix, $user_prefix, $JPCACHE_ON;
	if ($JPCACHE_ON) {
		return;
	}
	
	$out = "";
	
	if (! MX_IS_ADMIN && ! MX_IS_USER) {
		
		if (! defined ( "mxloginblockviewed" ))
			define ( "mxloginblockviewed", true );
		$nickname = _THEME_LOGINNICK;
		$password = _THEME_LOGINPASS;
		$login = _THEME_USERLOGIN;
		$userlogin = _THEME_USERLOGIN;
		$register = _THEME_REGISTER;
		$check = mxGetUserLoginCheckField ();
		$out .= <<<logform

		<li class="dropdown">
		
		<a title="" class="dropdown-toggle" 
		   role="button" aria-expanded="false" aria-haspopup="true" 
		   data-toggle="dropdown">
	        <i class="glyphicon glyphicon-user"></i> 
	        <i class="glyphicon glyphicon-chevron-down"></i>
	      </a>
	      <ul class="dropdown-menu">
<!-- ASU  		    <li><a href="modules.php?name=User_Registration" id="registerButton"><span class="glyphicon glyphicon-pencil" aria-hidden="true"></span> $register</a></li>   -->
<!-- ASU  		    <li><a href="modules.php?name=Your_Account&amp;op=login" id="LoginButton"><span class="glyphicon glyphicon-log-in" aria-hidden="true"></span> $login</a></li> -->
  		    <li><a href="admin.php" id="LoginButton"><span class="glyphicon glyphicon-log-in" aria-hidden="true"></span> Admin Login</a></li>
  		  </ul>
		</li>
logform;
	} else {
		
		$hallo = _THEME_HELLO;
		$logout = _THEME_LOGOUT;
		$delete = _THEME_DELETE;
		$account = _THEME_ACCOUNT;
		$userinfo = _THEME_USERINFO;
		$forumprofil = _THEME_FORUMPROFIL;
		$myevents = _THEME_MYEVENTS;
		$accountsettings = _THEME_ACCOUNTSETTINGS;
		$guestbook = _THEME_GUESTBOOK;
		$system = _AB_TITLEBAR;
		$adminStory = _SUBMITNEWS;
		$messages = _AB_MESSAGE;
		$settings = _AB_SETTINGS;
		$resetcache = _RESETPMXCACHE;
		$username = mxSessionGetVar ( 'user_uname' );
		
		// private Nachrichten
		$privatemessages = _THEME_PRIVATEMSG;
		if (mxModuleAllowed ( 'Private_Messages' )) { // falls pm-modul aktiv ist
			$qry = "SELECT count(msg_id) FROM ${prefix}_priv_msgs WHERE to_userid=" . ( int ) mxSessionGetVar ( 'user_uid' ) . " AND read_msg=0;";
			$result = sql_query ( $qry );
			list ( $count ) = sql_fetch_row ( $result );
			if ($count) { // wenn angemeldeter User
				$privatemessages = ' ' . sprintf ( (($count == 1) ? _THEME_MSGPM : _THEME_MSGSPM), $count ) . ' ';
			}
		}
		// // Usergaestebuch
		// $guestbook = _USERGUEST;
		// if (mxModuleAllowed('UserGuest')) { // falls gaestebuch vorhanden
		// $qry = "SELECT count(gid) FROM ${prefix}_userguest WHERE touserid=" . mxSessionGetVar('user_uid') . " AND touser = '" . $username . "' AND dummy=0;";
		// $result = sql_query($qry);
		// list($count) = sql_fetch_row($result);
		// if ($count) {
		// $guestbook = ' ' . sprintf((($count == 1) ? _THEME_MSGUG : _THEME_MSGSUG), $count) . ' ';
		// }
		// }
		
		if (! MX_IS_ADMIN) {
			
			$out .= <<<logform

	  <li class="dropdown">
	    <a class="dropdown-toggle" href="#" data-toggle="dropdown"><i class="glyphicon glyphicon-user"></i> <i class="glyphicon glyphicon-chevron-down"></i></a>
	    <ul class="dropdown-menu">
			
          <li><a href="modules.php?name=Your_Account&op=edituser" title="$accountsettings"><i class="glyphicon glyphicon-wrench"></i> $accountsettings</a></li>
          <li><a href="modules.php?name=Userinfo" title="$userinfo"><i class="glyphicon glyphicon-user"></i> $userinfo</a></li>
          <li><a href="modules.php?name=modules.php?name=Private_Messages" title="$privatemessages"><i class="glyphicon glyphicon-envelope"></i> $privatemessages</a></li>
          <li><a href="modules.php?name=UserGuest" title="$guestbook"><i class="glyphicon glyphicon-book"></i> $guestbook</a></li>
          <li><a href="modules.php?name=Forum&action=profile" title="$forumprofil"><i class="glyphicon glyphicon-list-alt"></i> $forumprofil</a></li>
          <li><a href="modules.php?name=Schedule&act=myevents" title="$myevents"><i class="glyphicon glyphicon-calendar"></i> $myevents</a></li>
          <li><a href="modules.php?name=Your_Account&op=delete" title="$delete"><i class="glyphicon glyphicon-trash"></i> $delete</a></li>
          <li class="divider"></li>
          <li><a href="modules.php?name=Your_Account&amp;op=logout" title="$logout"><i class="glyphicon glyphicon-log-out"></i> $logout</a></li>
        </ul>
      </li>

logform;
		} elseif (MX_IS_ADMIN && ! MX_IS_USER) {
			
			$out .= <<<logform

	  <li class="dropdown">
	    <a class="dropdown-toggle" href="#" data-toggle="dropdown"><i class="glyphicon glyphicon-user"></i> <i class="glyphicon glyphicon-chevron-down"></i></a>
	    <ul class="dropdown-menu">
		  <li><a href="admin.php?panel=system" title="$system"><i class="glyphicon glyphicon-cog"></i> $system</a></li>
          <li><a href="admin.php?op=News/adminStory" title="$adminStory"><i class="glyphicon glyphicon-edit"></i> $adminStory</a></li>
          <li><a href="admin.php?op=messages" title="$messages"><i class="glyphicon glyphicon-exclamation-sign"></i> $messages</a></li>
          <li><a href="admin.php?op=Configure" title="$settings"><i class="glyphicon glyphicon-wrench"></i> $settings</a></li>
          <li><a href="admin.php?op=reset/cache" title="$resetcache"><i class="glyphicon glyphicon-transfer"></i> $resetcache</a></li>
          <li><a href="admin.php?op=logout" title="$logout"><i class="glyphicon glyphicon-log-out"></i> $logout</a></li>
        </ul>
      </li>

logform;
		} else {
			
			$out .= <<<logform

	  <li class="dropdown">
	    <a class="dropdown-toggle" href="#" data-toggle="dropdown"><i class="glyphicon glyphicon-user"></i> <i class="glyphicon glyphicon-chevron-down"></i></a>
	    <ul class="dropdown-menu">
		
          <li><a href="modules.php?name=Your_Account&op=edituser" title="$accountsettings"><i class="glyphicon glyphicon-wrench"></i> $accountsettings</a></li>
          <li><a href="modules.php?name=Userinfo" title="$userinfo"><i class="glyphicon glyphicon-user"></i> $userinfo</a></li>
          <li><a href="modules.php?name=Private_Messages" title="$privatemessages"><i class="glyphicon glyphicon-envelope"></i> $privatemessages</a></li>
          <li><a href="modules.php?name=UserGuest" title="$guestbook"><i class="glyphicon glyphicon-book"></i> $guestbook</a></li>
          <li><a href="modules.php?name=Forum&action=profile" title="$forumprofil"><i class="glyphicon glyphicon-list-alt"></i> $forumprofil</a></li>
          <li><a href="modules.php?name=Schedule&act=myevents" title="$myevents"><i class="glyphicon glyphicon-calendar"></i> $myevents</a></li>
          <li><a href="modules.php?name=Your_Account&op=delete" title="$delete"><i class="glyphicon glyphicon-trash"></i> $delete</a></li>
          <li class="divider"></li>
          <li><a href="modules.php?name=Your_Account&amp;op=logout" title="$logout"><i class="glyphicon glyphicon-log-out"></i> $logout</a></li>
          <li class="divider"></li>
          <li><a href="admin.php?panel=system" title="$system"><i class="glyphicon glyphicon-cog"></i> $system</a></li>
          <li><a href="admin.php?op=News/adminStory" title="$adminStory"><i class="glyphicon glyphicon-edit"></i> $adminStory</a></li>
          <li><a href="admin.php?op=messages" title="$messages"><i class="glyphicon glyphicon-exclamation-sign"></i> $messages</a></li>
          <li><a href="admin.php?op=selfadmin" title="$settings"><i class="glyphicon glyphicon-wrench"></i> $settings</a></li>
          <li><a href="admin.php?op=reset/cache" title="$resetcache"><i class="glyphicon glyphicon-transfer"></i> $resetcache</a></li>
          <li><a href="admin.php?op=logout" title="$logout"><i class="glyphicon glyphicon-log-out"></i> $logout</a></li>
      </ul>
      </li>



logform;
		}
	}
	
	return $out;
}

/**
 * Beschreibung
 */
function theme_searchform() {
	$search = _SEARCH;
	
	$out = <<<searchform
	<li class="dropdown">
	<a class="dropdown-toggle" href="#" data-toggle="dropdown"><i class="glyphicon glyphicon-search"></i></a>
	<ul class="dropdown-menu" style="padding: 12px;">
	<form class="form-inline" method="get" action="modules.php">
	  <input type="hidden" name="name" value="Search" />
	  <button class="btn btn-success pull-right" type="submit"><i class="glyphicon glyphicon-search"></i></button>
	  <input type="text" class="form-controll pull-left" placeholder="$search ..." name="query" id="search-input" value="$search ..." onfocus="this.value = '';" onblur="if(this.value=='') this.value='$search ... ';" />
	</form>
	</ul>
	</li>
    
searchform;
	
	return $out;
}/**
 * Beschreibung
 */
function theme_searchform_old() {
	$search = _SEARCH;
	
	$out = <<<searchform
    <form class="navbar-form navbar-right" role="form" method="get" action="modules.php">
      <input type="hidden" name="name" value="Search" />
      <div class="form-group has-feedback">
      <input type="text" class="search-query" placeholder="$search ..." name="query" id="search-input" value="$search ..." onfocus="this.value = '';" onblur="if(this.value=='') this.value='$search ... ';" />
      <i class="glyphicon glyphicon-search form-control-feedback"></i>
      </div>
    </form>
searchform;
	
	return $out;
}

function theme_get_footmsg($MsgNo) {
	if ($GLOBALS ['foot' . $MsgNo]) {
		if (defined ( $GLOBALS ['foot' . $MsgNo] )) {
			$out = constant ( $GLOBALS ['foot' . $MsgNo] );
		} else {
			$out = $GLOBALS ['foot' . $MsgNo];
		}
	}
	return $out;
}

/**
 * Beschreibung
 */
function theme_footernav() {
	$statistics = _THEME_STATS;
	$newsletter = _NEWSLETTER;
	$faq = _FAQ;
	$contact = _THEME_CONTACT;
	$impressum = _IMPRESSUM;
	$legal = _LEGAL;
	$privacy = _THEME_PRIVACY;
	$top_ten = _TOP10;
	
	$out = <<<footernav

<ul class="footernav">
    <li class="icon-trophy">&nbsp;&nbsp;<a href="modules.php?name=Top" data-toggle="tooltip" titel="$top_ten"> $top_ten</a><li>
    <li class="icon-bar-chart">&nbsp;&nbsp;<a href="modules.php?name=Statistics" data-toggle="tooltip" titel="$statistics"> $statistics</a><li>
    <li class="icon-link">&nbsp;&nbsp;<a href="modules.php?name=Newsletter" data-toggle="tooltip" titel="$newsletter"> $newsletter</a><li>
    <li class="icon-question">&nbsp;&nbsp;<a href="modules.php?name=FAQ" data-toggle="tooltip" titel="$faq"> $faq</a><li>
    <li class="glyphicon glyphicon-envelope">&nbsp;&nbsp;<a href="modules.php?name=Feedback" data-toggle="tooltip" titel="$contact"> $contact</a><li>
    <li class="icon-info">&nbsp;&nbsp;<a href="modules.php?name=Impressum" data-toggle="tooltip" titel="$impressum"> $impressum</a><li>
    <li class="icon-legal">&nbsp;&nbsp;<a href="modules.php?name=legal" data-toggle="tooltip" titel="$legal"> $legal</a><li>
    <li class="icon-legal">&nbsp;&nbsp;<a href="modules.php?name=legal&amp;file=privacy" data-toggle="tooltip" titel="$privacy"> $privacy</a><li>
</ul>

footernav;
	
	return $out;
}

/**
 * parsen der Seiten-Bloecke
 *
 * Hier wird die pmx-Klasse "menu" auf "nav nav-pills nav-stacked" geändert!
 */
function themesidebox($title, $content, $block = array(), $noecho = 0) {
	global $theme_template, $themesetting;
	switch (true) {
		case empty ( $block ) :
		case empty ( $block ['position'] ) :
		case $block ['position'] === 'l' :
			$out = $theme_template ['block_left'];
			break;
		case $block ['position'] === 'r' :
			$out = $theme_template ['block_right'];
			break;
	}
	
	$content = str_replace ( '<ul class="menu', '<ul class="nav nav-pills nav-stacked', $content );
	$content = str_replace ( 'class="current', 'class="active', $content );
	
	$out = str_replace ( '{BLOCK_CONTENT}', $content, $out );
	$out = str_replace ( '{BLOCK_TITLE}', $title, $out );
	if ($noecho) {
		return $out;
	} else {
		echo $out;
	}
}

/**
 * parsen der Center-Bloecke
 */
function thememiddlebox($title, $content, $block = array(), $noecho = 0) {
	global $theme_template, $themesetting;
	
	$out = '';
	switch (true) {
		case empty ( $block ) :
		case empty ( $block ['position'] ) :
		case $block ['position'] === 'c' :
			$block ['position'] = 'c';
			$out = $theme_template ['block_center_top'];
			break;
		
		case $block ['position'] === 'd' :
			$out = $theme_template ['block_center_down'];
			break;
	}
	
	$out = str_replace ( '{BLOCK_CONTENT}', $content, $out );
	$out = str_replace ( '{BLOCK_TITLE}', $title, $out );
	if ($noecho) {
		return $out;
	} else {
		echo $out;
	}
}

/**
 * News Modul Artikelliste (index.php)
 * $x bedeutet: nicht verwendet, nur zur nuke-Modulkompatibilitaet
 */
function themeindex($x, $x, $x, $x, $x, $x, $x, $x, $x, $x, $x, $x, $story = array()) {
	global $theme_template;
	static $viewcounter;
	if (! isset ( $viewcounter ) || ($viewcounter == 2))
		$viewcounter = 0;
	$viewcounter ++;
	
	// nur eine Spalte zulassen :-)
	$GLOBALS ['storyhome_cols'] = 1;
	
	$story = theme_get_story ( $story );
	if (! empty ( $story ['allmorelink'] ['bodycount'] )) {
		$title = ($story ['allmorelink'] ['bodycount']) ? ' title="' . $story ['allmorelink'] ['bodycount'] . ' ' . _BYTESMORE . '"' : '';
		$story ['readmore'] = '<a href="modules.php?name=News&amp;file=article&amp;sid=' . $story ['sid'] . '" class="btn btn-primary" role="button"' . $title . '>  <span class="glyphicon glyphicon-circle-arrow-right"></span> ' . _HREADMORE . '</a>';
	} else {
		$title = '';
	}
	
	$story ['title'] = '<a href="modules.php?name=News&amp;file=article&amp;sid=' . $story ['sid'] . '" rel="bookmark"' . $title . '>' . strip_tags ( $story ['title'] ) . '</a>';
	
	$story ['notes'] = '';
	
	// ALA-Anfang
	// Lesen Image-File, falls vorhanden:
	// Beitrags-Aufmacher:
	preg_match_all ( "/src=\"(.+?)\"/i", $story ['hometext'], $src_from_text, PREG_SET_ORDER );
	if (! empty ( $src_from_text [0] [0] )) {
		// Image-Tag speichern
		preg_match_all ( "/<img[^>]+\>/i", $story ['hometext'], $img_from_text, PREG_SET_ORDER );
		// <a- Tag speichern
		preg_match_all ( "/<a[^>]+\>/i", $story ['hometext'], $a_from_text, PREG_SET_ORDER );
	
	
		// Entfernen der <img> - Tags:
		$story ['hometext'] = preg_replace ( "/<img[^>]+\>/i", "", $story ['hometext'] );
		$story ['content'] = preg_replace ( "/<img[^>]+\>/i", "", $story ['content'] );
	} else {
		// sonst Erweiterter Text
		preg_match_all ( "/src=\"(.+?)\"/i", $story ['bodytext'], $src_from_text, PREG_SET_ORDER );
		// Image-Tag speichern
		preg_match_all ( "/<img[^>]+\>/i", $story ['bodytext'], $img_from_text, PREG_SET_ORDER );
		// <a- Tag speichern
		preg_match_all ( "/<a[^>]+\>/i", $story ['bodytext'], $a_from_text, PREG_SET_ORDER );
	}
	
	// die alt='' filtern:
	if (! empty ( $img_from_text [0] [0] )) {
		preg_match_all ( "/alt=\"(.*?)\"/i", $img_from_text [0] [0], $alt_from_img, PREG_SET_ORDER );
		$c_alt = (! empty ( $alt_from_img [0] [0] )) ? $alt_from_img [0] [0] : '';
	} else
		$c_alt = '';
	// das title='' filtern:
	if (! empty ( $a_from_text [0] [0] )) {
		preg_match_all ( "/title=\"(.*?)\"/i", $a_from_text [0] [0], $title_from_a, PREG_SET_ORDER );
		$c_title = (! empty ( $title_from_a [0] [0] )) ? $title_from_a [0] [0] : '';
	} else
		$c_title = '';
	
	if (! empty ( $src_from_text [0] [0] )) {
		// $story['image_src'] = '<img ' . $img_from_text[0][0] . '>';
		$my_href = str_replace ( 'src=', 'href=', $src_from_text [0] [0] );
		$story ['image_src'] = '<a rel="pretty" ' . $c_title . ' style="cursor: pointer;" ' . $my_href . ' shape="rect" ><img ' . $c_alt . ' ' . $src_from_text [0] [0] . '></a>';
	} else {
		$story ['image_src'] = '';
	}
	$story ['image_align'] = ($viewcounter == 1) ? 'alignleft' : 'alignright';
	// mxDebugFuncvars($story);
	// ALA-Ende
	
	// die oben definierten Variablen in dem passenden templateteil ersetzen
	$artvars = theme_define_content ();
	$out = theme_replace_vars ( $theme_template [$artvars ['themeindex']], $story );
	
	echo $out;
	// echo '<article>' . $out . '</article>';
	return;
}

/**
 * News Modul Artikelansicht (article.php)
 * $x bedeutet: nicht verwendet, nur zur nuke-Modulkompatibilitaet
 */
function themearticle($x, $x, $x, $x, $x, $x, $x, $x, $x, $story = array()) {
	global $theme_template;
	
	$story = theme_get_story ( $story );
	
	$story ['title'] = strip_tags ( $story ['title'] );
	$story ['content'] .= "<br />\n" . $story ['bodytext'];
	$story ['notes'] = (empty ( $story ['notes'] )) ? '' : '<dl class="post-notes"><dt>' . _NOTE . '</dt><dd>' . $story ['notes'] . '</dd></dl>';
	// die oben definierten Variablen in dem passenden templateteil ersetzen
	echo theme_replace_vars ( $theme_template ['themearticle'], $story );
	return;
}

/**
 * theme_get_story()
 *
 * @param mixed $story        	
 * @return
 *
 */
function theme_get_story($story) {
	$story ['comments'] = '';
	$story ['readmore'] = '';
	$story ['content'] = $story ['hometext'];
	
	$story ['title'] = strip_tags ( $story ['title'] );
	
	if (is_file ( $GLOBALS ['tipath'] . $story ['topicimage'] )) {
		$story ['topicimage'] = $GLOBALS ['tipath'] . $story ['topicimage'];
	} else {
		$story ['topicimage'] = $GLOBALS ['tipath'] . 'AllTopics.gif';
	}
	$story ['topictitle'] = _TOPIC . ': ' . $story ['topictext'];
	
	$dat = strtotime ( $story ['time'] );
	$story ['posted_year'] = strftime ( '%Y', $dat );
	$story ['posted_month'] = strftime ( '%b', $dat );
	$story ['posted_day'] = date ( 'd', $dat );
	
	$authorinfo = (empty ( $story ['informant'] ) || $story ['informant'] == $GLOBALS ['anonymous']) ? theme_adminname ( $story ) : " " . $story ['allmorelink'] ['informantlink'] . $story ['informant'] . "</a>";
	$story ['infoline1'] = _NEWSSUBMITED . " " . $authorinfo;
	
	$story ['infoline2'] = _THEME_IN . ' <a href="modules.php?name=News&amp;topic=' . $story ['topic'] . '">' . $story ['topictext'] . '</a>';
	$story ['infoline3'] = '<a href="modules.php?name=News&amp;file=article&amp;sid=' . $story ['sid'] . '#comments" class="comments"><span class="label">' . $story ['allmorelink'] ['comments'] . '</span></a>';
	$story ['author'] = $authorinfo;
	$story ['newsgroup'] = '<a href="modules.php?name=News&amp;topic=' . $story ['topic'] . '">' . $story ['topictext'] . '</a>';
	
	return $story;
}


function theme_get_tag_rss(){
	global $themesetting;
	if (trim($themesetting['rsslink'])!="") {
		return '<a href="'.$themesetting['rsslink'].'" data-toggle="tooltip" target="_blank" title="' . _THEME_RSS . '" ><i class="icon-rss icon-large"></i></a>';
	} else {
		return "";
	}	
}
function theme_get_tag_facebook(){
	global $themesetting;
	if (trim($themesetting['facebooklink'])!="") {
		return '<a href="'.$themesetting['facebooklink'].'" data-toggle="tooltip" target="_blank" title="' . _THEME_FACEBOOK . '" ><i class="icon-facebook icon-large"></i></a>';
	} else {
		return "";
	}
}function theme_get_tag_twitter(){
	global $themesetting;
	if (trim($themesetting['twitterlink'])!="") {
		return '<a href="'.$themesetting['twitterlink'].'" data-toggle="tooltip" target="_blank" title="' . _THEME_TWITTER . '" ><i class="icon-twitter icon-large"></i></a>';
	} else {
		return "";
	}
}

/**
 * theme_get_mxmenu()
 * CSS-Menü aus dem Menümanager auslesen
 *
 * @return string
 */
function theme_get_mxmenu() {
	global $themesetting;
	
	load_class ( 'Menu', false );
	
	$menu = pmxMenu::get_menu_instance ( $themesetting ['head_css_menu'] );
	$menu->template_path = MX_THEME_DIR . '/templates';
	$menu->template = 'theme.menu.html'; // in __construct
	$menu->class_current = 'active';
	$menu->class_parent = 'dropdown';
	$menu->class_home = '';
	$menu->class_first = '';
	$menu->class_last = '';
	$menu->class_disabled = '';
	$menu->class_nolink = '';
	$menu->class_sublevel = '';
	$menu->class_additional = '';
	
	if (MX_IS_ADMIN && ! $menu->get_tree ()) {
		return '<div class="warning">' . sprintf ( _THEME_MENU_NOT_EXIST, $themesetting ['head_css_menu'] ) . ' [<a href="admin.php?op=menu">' . _MX_MENU_ADDMENU_EDIT . '</a>]</div>';
	}
	
	$content = $menu->fetch ();
	$menu = null;
	
	return $content;
}

/**
 * theme_get_mxmenu()
 * CSS-Menü aus dem Menümanager auslesen
 *
 * @return string
 */
function ala_theme_get_mxmenu() {
	global $themesetting;
	
	load_class ( 'Menu', false );
	
	$menu = pmxMenu::get_menu_instance ( $themesetting ['head_css_menu'] );
	
	$menutree = $menu->get_tree ();
	$topmenu = $menutree [0] ['sub'];
	// mxDebugFuncvars($topmenu);
	// mxDebugFuncvars($menutree);
	
	/* Template initialisieren */
	$template_object = load_class ( 'Template' );
	$template_object->assign ( 'topmenu', $topmenu );
	$template_object->assign ( 'menutree', $menutree );
	$out = $template_object->fetch ( MX_THEME_DIR . '/templates/theme.menu.html' );
	
	// mxDebugFuncvars($out);
	return $out;
	
	$menu->template_path = MX_THEME_DIR . '/templates';
	$menu->template = 'theme.menu.html'; // in __construct
	$menu->class_current = '';
	$menu->class_parent = '';
	// $menu->class_additional = '';
	if (MX_IS_ADMIN && ! $menu->get_tree ()) {
		return '<div class="warning">' . sprintf ( _THEME_MENU_NOT_EXIST, $themesetting ['head_css_menu'] ) . ' [<a href="admin.php?op=menu">' . _MX_MENU_ADDMENU_EDIT . '</a>]</div>';
	}
	
	$content = $menu->fetch ();
	// mxDebugFuncvars($menu);
	
	$menu = null;
	
	return $content;
}

/**
 * theme_preview_settings()
 * Theme-Einstellungen über Demo-Block steuern
 * (reserviert für pragmaMx Entwicklerteam)
 *
 * @param mixed $themesetting        	
 * @return
 *
 */
function theme_preview_settings(&$themesetting) {
	if ($file = realpath ( _THISTHEME_ . '/theme.vars.ini' )) {
		$requestname = 'thset_' . basename ( _THISTHEME_ );
		if (isset ( $_POST [$requestname] )) {
			$newvals = $_POST [$requestname];
		} else {
			$newvals = mxSessionGetVar ( $requestname );
		}
		if ($newvals && is_array ( $newvals )) {
			$setting = parse_ini_file ( $file, true );
			$session = array ();
			foreach ( $newvals as $key => $value ) {
				if (isset ( $setting [$key] ) && in_array ( $value, $setting [$key] )) {
					$themesetting [$key] = $value;
					$session [$key] = $value;
				}
			}
			mxSessionSetVar ( $requestname, $session );
		}
	}
}

?>