<?php
/**
 * This file is part of Theme for 
 * pragmaMx - Web Content Management System.
 *
 * $template : alaSimpleBT $
 * $Revision: 1.0 $
 * 
 * Theme for pragmaMx Content Management System Platform<br>- HTML5 ready <br>
 * 
 * $Version: 1.0 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/06/16  $
 *
 */
defined('mxMainFileLoaded') or die('access denied');

define('_THISTHEME_', dirname(__FILE__));
define('_THISTHEMENAME_',basename(dirname(__FILE__)));

/* Sprachdatei auswaehlen */
mxGetLangfile(_THISTHEME_ . DS . 'language');

global $themesetting; // global muss drin bleiben, weil das in einer Funktion includet wird !!
$themesetting = array();

include_once(_THISTHEME_ . '/includes/class.theme_functions.php');
$theme_config = new theme_functions(_THISTHEMENAME_);

require(_THISTHEME_ . '/theme.settings.php');
require(_THISTHEME_ . '/theme.colors.php');
require_once(_THISTHEME_ . '/includes/theme.functions.php');

/* Die Theme-Settings aus Admin kommen dazu */
$themesetting2=$theme_config->config_load();
$themesetting=array_merge($themesetting,$themesetting2);

/* Welcher Browser ist aktiv? */
$theme_browser = load_class('Browser');
$themesetting['browser']=" ".$theme_browser->browser();

/* nur wenn theme.php normal verwendet wird, nicht fuer CSS */
if (!defined('DONT_INIT_THEME') || DONT_INIT_THEME == false) {
    /* zu alte pragmaMx-Version */
    if (version_compare(PMX_VERSION, '2.1', '<')) {
        die('<br />Sorry, theme "' . basename(_THISTHEME_) . '" requires pragmaMx version >= 2.1.');
    }
	
    /* die themeEngine laden */
    include_once(PMX_SYSTEM_DIR . '/mx_themes.php');

    /* bei Bedarf den Dokumenttyp anpassen :) */
    if (!theme_check_xhtmldoctype()) {
        $GLOBALS['DOCTYPE'] = '6';
    }
}

// Responsive Design
$viewport='content="initial-scale = 1.0, maximum-scale = 1.0, user-scalable = no, width = device-width"';
pmxHeader::set_meta("viewport",$viewport);


if (file_exists(_THISTHEME_."/favicon.ico")) pmxHeader::add("<link rel=\"shortcut icon\" href=\"" . PMX_HOME_URL . "/themes/" ._THISTHEMENAME_. "/favicon.ico\" type=\"image/x-icon\" />");


/* Drucklayout */
pmxHeader::add_style ( _THISTHEME_ . '/style/print.css', 'print' );

//<!-- Bootstrap core CSS -->
pmxHeader::add_style ( _THISTHEME_ . '/style/bootstrap.min.css' );
//<!-- Bootstrap theme -->
pmxHeader::add_style ( _THISTHEME_ . '/style/bootstrap-theme.min.css' );
// AddOn: Bootstrap-select
pmxHeader::add_style ( _THISTHEME_ . '/style/bootstrap-select.min.css');
//<!-- Custom styles for this template -->
pmxHeader::add_style ( _THISTHEME_ . '/style/style.css' );

//<!-- FontAwesome einbinden (für Social-Media Icons...) -->
pmxHeader::add_style ( _THISTHEME_ . '/style/font-awesome.css' );

//<!-- Custom styles from me-->
pmxHeader::add_style ( _THISTHEME_ . '/style/my-add.min.css' );


/* JavaScripts */
//pmxHeader::add_script ("https://ajax.googleapis.com/ajax/libs/jquery/1.11.2/jquery.min.js");
pmxHeader::add_jquery();

pmxHeader::add_script ( _THISTHEME_ . '/js/bootstrap.min.js' );
pmxHeader::add_script ( _THISTHEME_ . '/assets/js/docs.min.js');
    // <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
pmxHeader::add_script ( _THISTHEME_ . '/assets/js/ie10-viewport-bug-workaround.js');

/* PNG-Fix für alten IE < 7 */
if ($theme_browser->msie && $theme_browser->version < 8) {
	pmxHeader::add_style(_THISTHEME_."/style/style.ie7.css");
}

// AddOn: Bootstrap-select
pmxHeader::add_script(MX_THEME_DIR . '/js/bootstrap-select.min.js');

/* scrollUp initialisieren */
pmxHeader::add_script(MX_THEME_DIR . '/js/jquery.scrollUp.min.js');
pmxHeader::add_script_code("/* scrollUp full options*/
    $(function () {
        $.scrollUp({
            scrollName: 'scrollUp', // Element ID
            topDistance: '300', // Distance from top before showing element (px)
            topSpeed: 300, // Speed back to top (ms)
            animation: 'fade', // Fade, slide, none
            animationInSpeed: 200, // Animation in speed (ms)
            animationOutSpeed: 200, // Animation out speed (ms)
            scrollText: '" . _THEME_SCROLLTOTOP . "', // Text for element
            activeOverlay: false, // Set CSS color to display scrollUp active point, e.g '#00FFFF'
        });
    });
");


?>
